package cn.ibizlab.businesscentral.core.base.service.logic.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.KieContainer;

import cn.ibizlab.businesscentral.core.base.service.logic.ITaskDraftByParentLogic;
import cn.ibizlab.businesscentral.core.base.domain.Task;

/**
 * 关系型数据实体[DraftByParent] 对象
 */
@Slf4j
@Service
public class TaskDraftByParentLogicImpl implements ITaskDraftByParentLogic{

    @Autowired
    private KieContainer kieContainer;


    @Autowired
    private cn.ibizlab.businesscentral.core.base.service.ITaskService iBzSysDefaultService;

    public cn.ibizlab.businesscentral.core.base.service.ITaskService getIBzSysDefaultService() {
        return this.iBzSysDefaultService;
    }

    public void execute(Task et){

          KieSession kieSession = null;
        try{
           kieSession=kieContainer.newKieSession();
           kieSession.insert(et); 
           kieSession.setGlobal("taskdraftbyparentdefault",et);
           kieSession.setGlobal("iBzSysTaskDefaultService",iBzSysDefaultService);
           kieSession.setGlobal("curuser", cn.ibizlab.businesscentral.util.security.AuthenticationUser.getAuthenticationUser());
           kieSession.startProcess("cn.ibizlab.businesscentral.core.base.service.logic.taskdraftbyparent");

        }catch(Exception e){
            throw new RuntimeException("执行[根据父获取草稿]处理逻辑发生异常"+e);
        }finally {
            if(kieSession!=null)
            kieSession.destroy();
        }
    }

}
